﻿using AphidUI.ViewModels;
using Components.Aphid.Interpreter;
using Components.Aphid.Lexer;
using Components.Aphid.Library;
using Components.Aphid.Parser;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.IO;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace AphidUI
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            var vm = new WindowViewModel(OutputTextBox2);
            vm.Init();

            KeyDown += vm.MainWindow_KeyDown;
            ExpressionTextBox.PreviewKeyDown += vm.InputTextBox_KeyDown;
            ClearMenuItem.Click += vm.ClearCodeHandler;
            ResetMenuItem.Click += vm.ResetInterpreterHandler;

            DataContext = vm;
        }
    }
}
